package top.meethigher.mock.instance;



import net.bytebuddy.ByteBuddy;
import net.bytebuddy.dynamic.DynamicType;
import net.bytebuddy.implementation.FixedValue;
import net.bytebuddy.matcher.ElementMatchers;
import top.meethigher.mock.instance.proxy.MockInstanceHandler;

public class Test {



    public static void main(String[] args) throws InstantiationException, IllegalAccessException {

//        //第一种方式，有注解：需要参考一下Lombok的做法
//        //@MockInstance
//        //ObjectTest objectTest=new ObjectTest();
//
//        //第二种方式，无注解
//        ObjectTest objectTest = new MockInstanceHandler().instance(ObjectTest.class);
//
//        /**
//         * toString获取内容如下
//         * <p>
//         * ObjectTest objectTest=new ObjectTest();
//         * objectTest.setMoney("money-test");
//         * objectTest.setName("name-test");
//         * </p>
//         */
////        System.out.println(objectTest.toString());
//
//        /**
//         * 获取内容如下
//         * <p>
//         * name-test
//         * </p>
//         */
//        System.out.println(objectTest.getName());

        Class<?> dynamicType = new ByteBuddy()
                .subclass(Object.class)
                .method(ElementMatchers.named("toString"))
                .intercept(FixedValue.value("Hello World"))
                .make()
                .load(ObjectTest.class.getClassLoader())
                .getLoaded();

        ObjectTest instance = (ObjectTest)dynamicType.newInstance();
        String toString = instance.toString();
        System.out.println(toString);
        System.out.println(instance.getClass().getCanonicalName());

    }
}
